/************************************************************************************************/
/**
* @file               common.c
* @author             MCU Ecosystem Development Team
* @brief              通用函数或本外设相关的配置实现函数。
*
*
**************************************************************************************************
* @attention
* Copyright (c) CEC Huada Electronic Design Co.,Ltd. All rights reserved.
*
**************************************************************************************************
*/

/*------------------------------------------includes--------------------------------------------*/
#include "common.h"

/*-------------------------------------------functions------------------------------------------*/


/**
* @brief  系统时钟配置
* @retval 无
*/
void system_clock_config(void)
{
    uint32_t ahbdiv_tmp;
    
    /* 设置Flash读访问等待时间 */
    std_flash_set_latency(FLASH_LATENCY_1CLK);

    /* 使能RCH */
    std_rcc_rch_enable();
    while(!std_rcc_get_rch_ready());
    
    /* 备份AHB分频参数 */
    ahbdiv_tmp = std_rcc_get_ahbdiv();    
    /* 配置AHB最大分频：128分频 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV128);  
    
    /* 切换RCH4到RCH48 */    
    std_rcc_set_rch_source(RCC_RCH_FREQ_48M);
    
    /* 恢复AHB分频参数 */
    std_rcc_set_ahbdiv(ahbdiv_tmp);      

    /* 设置系统时钟源为RCH */
    std_rcc_set_sysclk_source(RCC_SYSCLK_SRC_RCH);
    while(std_rcc_get_sysclk_source() != RCC_SYSCLK_SRC_STATUS_RCH);

    /* 设置AHB分频因子 */
    std_rcc_set_ahbdiv(RCC_HCLK_DIV1);
    /* 设置APB分频因子 */
    std_rcc_set_apbdiv(RCC_PCLK_DIV1);
    
    SystemCoreClockUpdate(); 
}

/**
* @brief  GPIO 初始化
* @retval 无
*/
void gpio_init(void)
{
    std_gpio_init_t gpio_config = {0};
    
    /* GPIO外设时钟使能 */  
    std_rcc_gpio_clk_enable(RCC_PERIPH_CLK_GPIOA);

    /* GPIO引脚配置  
        PA12   ------> UART1 TX引脚 复用开漏模式
        PA9    ------> UART2 TX引脚 复用开漏模式
    */  
    gpio_config.pin = GPIO_PIN_12;
    gpio_config.mode = GPIO_MODE_ALTERNATE;
    gpio_config.output_type = GPIO_OUTPUT_OPENDRAIN;
    gpio_config.pull = GPIO_PULLUP;
    gpio_config.alternate = GPIO_AF1_UART1;
    std_gpio_init(GPIOA, &gpio_config);
    
    gpio_config.pin = GPIO_PIN_9;
    gpio_config.mode = GPIO_MODE_ALTERNATE;
    gpio_config.output_type = GPIO_OUTPUT_OPENDRAIN;
    gpio_config.pull = GPIO_PULLUP;
    gpio_config.alternate = GPIO_AF2_UART2;
    std_gpio_init(GPIOA, &gpio_config);
}


/**
* @brief  UART 初始化
* @retval 无
*/
void uart_init(void)
{
    std_uart_init_t uart_config ={0};
    
    /* UART1、2时钟使能 */
    std_rcc_apb2_clk_enable(RCC_PERIPH_CLK_UART1);
    std_rcc_apb1_clk_enable(RCC_PERIPH_CLK_UART2);
    
    /* UART1 初始化 */     
    uart_config.baudrate = 115200;
    uart_config.wordlength = UART_WORDLENGTH_8BITS;
    uart_config.stopbits = UART_STOPBITS_1;
    uart_config.parity = UART_PARITY_NONE;
    uart_config.direction = UART_DIRECTION_SEND_RECEIVE; 
    /* UART初始化 */   
    if(STD_OK != std_uart_init(UART1,&uart_config))
    {
        /* 波特率配置不正确处理代码 */
        while(1);
    }
    std_uart_enable(UART1);

    /* UART2 初始化 */        
    uart_config.baudrate = 115200;
    uart_config.wordlength = UART_WORDLENGTH_8BITS;
    uart_config.stopbits = UART_STOPBITS_1;
    uart_config.parity = UART_PARITY_NONE;
    uart_config.direction = UART_DIRECTION_SEND_RECEIVE;
    /* UART初始化 */   
    if(STD_OK != std_uart_init(UART2,&uart_config))
    {
        /* 波特率配置不正确处理代码 */
        while(1);
    }
    std_uart_enable(UART2);
}



